<template>
  <v-app>
    <v-container fluid>
      <v-row no-gutters>
        <v-col cols="7" class="main-part d-none d-md-none d-lg-flex">
          <div class="d-flex">
            <v-img src="@/assets/logo.png" contain></v-img>
            <p>СПбГТИ(ТУ)</p>
          </div>
        </v-col>
        <v-col
          cols="12"
          lg="5"
          class="login-part d-flex align-center justify-center"
        >
          <v-row no-gutters>
            <v-col
              cols="12"
              class="login-part d-flex align-center justify-center flex-column"
            >
              <div class="login-wrapper">
                <v-tabs grow>
                  <v-tabs-slider></v-tabs-slider>
                  <v-tab :href="`#tab-login`"> Вход </v-tab>
                  <v-tab :href="`#tab-newUser`"> Регистрация </v-tab>

                  <v-tab-item :value="'tab-login'">
                    <v-form>
                      <v-container>
                        <v-row class="flex-column">
                          <v-col>
                            <p
                              class="login-slogan display-2 text-center font-weight-medium mt-10"
                            >
                              Авторизация
                            </p>
                          </v-col>
                          <v-col cols="12" class="d-flex align-center"> </v-col>
                          <v-form v-model="isLoginValid">
                            <v-col>
                              <v-text-field
                                v-model="email"
                                label="Username"
                                required
                                @keyup.enter="trigger"
                              ></v-text-field>
                              <v-text-field
                                v-model="password"
                                :rules="passRules"
                                type="password"
                                label="Password"
                                hint="At least 6 characters"
                                required
                                @keyup.enter="login"
                              ></v-text-field>
                            </v-col>
                            <v-col class="d-flex justify-space-between">
                              <v-btn
                                ref="loginBtn"
                                large
                                block
                                :disabled="!isLoginValid
                                "
                                color="primary"
                                @click="login"
                              >
                                Login</v-btn
                              >
                            </v-col>
                          </v-form>
                        </v-row>
                      </v-container>
                    </v-form>
                  </v-tab-item>

                  <v-tab-item :value="'tab-newUser'">
                    <v-form>
                      <v-container>
                        <v-row class="flex-column">
                          <v-col>
                            <p
                              class="login-slogan display-2 text-center font-weight-medium mt-10"
                            >
                              Регистрация
                            </p>
                          </v-col>
                          <v-form v-model="isRegisterValid">
                            <v-col>
                              <v-text-field
                                v-model="createFullName"
                                label="Username"
                                required
                              ></v-text-field>
                              <v-text-field
                                v-model="createPassword"
                                :rules="passRules"
                                type="password"
                                label="Password"
                                hint="At least 6 characters"
                                required
                                @keyup.enter="register"
                              ></v-text-field>
                            </v-col>
                            <v-col class="d-flex justify-space-between">
                              <v-btn
                                large
                                block
                                :disabled="!isRegisterValid"
                                color="primary"
                                @click="register"
                              >
                                Create your account</v-btn
                              >
                            </v-col>
                          </v-form>
                        </v-row>
                      </v-container>
                    </v-form>
                  </v-tab-item>
                </v-tabs>
              </div>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-container>
  </v-app>
</template>

<script lang="ts">
import UserModule from "@/store/modules/user";
import Vue from "vue";
import { Component } from "vue-property-decorator";
import { getModule } from "vuex-module-decorators";
import "./Login.scss";

@Component
export default class Login extends Vue {
  private userStore = getModule(UserModule, this.$store);
  private isLoginValid = false;
  private isRegisterValid = false;

  email = "";
  createFullName = "";
  createPassword = "";
  password = "";
  passRules = [
    (v: string) => !!v || "Password is required",
    (v: string) => v.length >= 6 || "Min 6 characters",
  ];
  login() {
    this.userStore.login({ username: this.email, password: this.password });
  }
  register() {
    this.userStore.register({ username: this.createFullName, password: this.password });
  }

  created() {
    if (this.userStore.status.loggedIn) {
      this.$router.push("/dashboard");
    }
  }
}
</script>

<style src="./Login.scss" lang="scss"/>
